\section{Introduction}

\subsection{Project Documentation}
Project planning and documentation are two really hard things in every software project. Most people try to do good planning and documentation but fail at both. Here we take a closer look on how to success on planning and documentation. The aim of a software project is not to generate documentation, but a usable product.

\subsection{Four quadrants of documentation}
Typically the documentation of a project can be divided into four different parts. First the requirements are written with which we later build the technical solution. These two are called the product documentation. On the other side we have the project documentation. The content of this is the documentation of the project. Please keep in mind that the goal of software projects is not to create documentation, but a good, usable software.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.6\textwidth]{fourquadrants}
  \caption{Four Quadrants of Documentation}
\end{figure}

\begin{description}
  \item[Rquirements] What the customer wants.
  \item[Technical Solution] How we are building the solution.
  \item[Project Planning] How we are working.
  \item[Project Tracking] Our current state of work.
\end{description}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{fqodcontent}
  \caption{Contents of the four quadrants}
\end{figure}

\subsection{Project Planning}
\paragraph{Definition}
\begin{quote}
	A statement of how and when a project's objectives are to be achieved, by showing the major products, milestones, activities and resources required on the project.	
\end{quote}

\paragraph{Topics to include into a project plan:}
\begin{itemize}
  \itemsep -0.2em
  \item Ressources (People, Time, Cost)
  \item Organization and Roles
  \item Processes and Meetings
  \item Estimated Scope
  \item Scheudeles (Phases, Iterations, Milestones, etc..)
  \item Risk Management
\end{itemize}

\paragraph{When to create a project plan?}
An initial draft is created at the beginning of the software project. You will always learn a lot during the project and therefore make sure to refine the. project plan regularly. \\


\textbf{Traditional vs. Agile Planing}
\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{methodologies.png}
  \caption{Methodologies}
\end{figure}


\paragraph{Planning on multiple levels}
There are two common planning levels: \textbf{Long-term planning:} with a rough scope and \textbf{Short-term planning:} with a detailed scope.

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.5\textwidth]{planinglevels}
  \caption{Planing Levels in an Onion Type and Form}
\end{figure}

\subsubsection{Rational Unified Process (RUP)}
Rational Unified Process (RUP) is an agile software development method, in which the life cycle of a project, or the development of software, is divided into four phases. Various activities take place during these phases: modelling, analysis and design, implementation, testing and application.

\begin{description}
  \item[Inception] Approximate vision, Defining the scope, Rough estimates for efforts.
  \item[Elaboration] Identification of most requirements, iterative implementation of core architecture, Resolution of high risks, More realistic estimates for efforts.
  \item[Construction] Iterative implementation of functionality, Resolution of lower risks, Preparation for deployment.
  \item[Transition] Beta tests, Deployment of the solution, Tie up any loose ends.
\end{description}

\begin{figure}[hbt]
  \center
  \includegraphics[width=0.5\textwidth]{rup}
  \caption{Rational Unified Process}
\end{figure}

\subsubsection{Scrum+}
Is the combination of RUP and Scrum and therefore tries to combine the best of both worlds (OST-specific term). For the long term planning and disciplines RUP is used and for the short therm planning we use the iterations from Scrum.

\subsubsection{Risk Management}
We need to be aware of possible risks in order to: prioritise high-risk tasks, avoid high-risk tasks, incorporate time-buffers into planning, react faster in case of an emergency. Risk Management is a continuous process and not a one time job. New risk may arise during the project and existing risk may change. 

The Risk Matrix is a common tool used for the risk assessment.

\begin{figure}[h]
  \center
  \includegraphics[width=0.5\textwidth]{riskmatrix}
  \caption{Risk Matrix for Risk Management}
\end{figure}

\subsection{Project Tracking}
Project planning focuses on the desired state and the project tracking on the actual state. The project plan describes how the project tracking is done. Common topics:  Work items, Time Tracking, Meeting Minutes, Project Metrics, Reviews / Retrospectives.

\subsubsection{Work Items}
For planning an iteration, fine-grained work items are needed. Work items result from different sources. Everything the team will invest time on, should be a work item.

\subsubsection{Time Tracking and Reporting}
\begin{description}
  \item[Time Tracking] is tightly coupled with work items. Most tools support tracking directly on work items. There must be a consense about the accuracy (15/30min) of the time tracking. Make also sure to track idle times such as meetings, writing, phone calls etc.
  \item[Time Reporting] should focus on the big picture. Are the estimates enough? Are the efforts balanced across the team? Are we fast enough to finish the project on time?
\end{description}




